import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkMessage, ThinkMessageParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询消息表
 */
export async function pageThinkMessage(params: ThinkMessageParam) {
  const res = await request.get<ApiResult<PageResult<ThinkMessage>>>(
    THINK_API_URL + '/think/think-message/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询消息表列表
 */
export async function listThinkMessage(params?: ThinkMessageParam) {
  const res = await request.get<ApiResult<ThinkMessage[]>>(
    THINK_API_URL + '/think/think-message',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加消息表
 */
export async function addThinkMessage(data: ThinkMessage) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-message',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改消息表
 */
export async function updateThinkMessage(data: ThinkMessage) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-message',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除消息表
 */
export async function removeThinkMessage(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-message/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除消息表
 */
export async function removeBatchThinkMessage(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-message/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询消息表
 */
export async function getThinkMessage(id: number) {
  const res = await request.get<ApiResult<ThinkMessage>>(
    THINK_API_URL + '/think/think-message/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
